#!/bin/bash
# Copyright © 2019-2023 Collabora Ltd.
# SPDX-License-Identifier: BSD-3-Clause
# (See debian/copyright)

set -e
set -u
set -x

case "$(dpkg --print-architecture)" in
    (amd64|i386)
        ;;
    (*)
        echo "1..0 # SKIP - not x86"
        exit 0
        ;;
esac

# Test that we can compile a simple project using meson and ninja.

tmpdir="$(mktemp -d)"
cleanup () {
    rm -fr "$tmpdir"
}
trap cleanup 0 INT QUIT ABRT PIPE TERM

# Meson wants a real locale
export LC_ALL=C.UTF-8

n=0
failed=

gcc_major=$(gcc -dumpversion)

for compiler in \
    gcc \
    gcc/mold \
    "gcc-${gcc_major}" \
    "gcc-${gcc_major}/mold" \
; do
    n=$((n + 1))
    linker=

    case "$compiler" in
        (gcc | "gcc-${gcc_major}")
            # default version, guaranteed to be present in SDK
            ;;

        (*/mold)
            compiler="${compiler%/*}"
            linker=mold
            ;;

        (*)
            if ! command -v "$compiler" >/dev/null; then
                echo "ok $n # SKIP $compiler not in PATH"
                continue
            fi
            ;;
    esac

    if \
        meson setup \
            --cross-file "${compiler}-m32.txt" \
            ${linker:+--cross-file "${linker}.txt"} \
            "$tmpdir/b" \
            "$(pwd)/examples/glib" \
        && ninja -v -C "$tmpdir/b" \
        && "$tmpdir/b/hello" \
    ; then
        echo "ok $n - ${compiler:-default}${linker:+/"$linker"}"
    else
        echo "not ok $n - ${compiler:-default}${linker:+/"$linker"}"
        failed=1
    fi

    if [ "$linker" = "mold" ]; then
        n=$((n + 1))

        if strings "$tmpdir/b/hello" | grep '^mold [0-9]' >&2; then
            echo "ok $n - $tmpdir/b/hello was linked with mold"
        else
            echo "not ok $n - $tmpdir/b/hello not linked with mold"
            failed=1
        fi
    fi

    ninja -v -C "$tmpdir/b" clean
    rm -fr "$tmpdir/b"
done

echo "1..$n"

if [ -n "$failed" ]; then
    exit 1
fi

# vim:set sw=4 sts=4 et ft=sh:
